Page MenuHomePhabricator

update: filter the ambiguous mtime in update directly
ClosedPublic

Authored by marmoute on Nov 24 2021, 6:11 AM.

Details

Summary

Right now, this filtering is done by dirstate.write using the time of
dirstate.write method call. However that filtering is done "too late"
It works "fine" as most command are "fast enough", and race rare enough.
We are about to change the mtime filtering logic in the dirstate to be more
accurate and reliable.

However hg update will still need such filtering (mostly because it is
actually quite racy, even with the existing filtering). So we explicitly
implement a similar logic here. Before removing the older one later in the
series.

Diff Detail

Repository
rHG Mercurial
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

marmoute created this revision.Nov 24 2021, 6:11 AM
Alphare requested changes to this revision.Nov 24 2021, 8:18 AM
Alphare added a subscriber: Alphare.
Alphare added inline comments.
mercurial/merge.py
2190

Not sure what this sentence was supposed to be

This revision now requires changes to proceed.Nov 24 2021, 8:18 AM
marmoute edited the summary of this revision. (Show Details)Nov 30 2021, 6:53 PM
marmoute updated this revision to Diff 31225.
Alphare accepted this revision.Dec 1 2021, 5:09 AM
This revision is now accepted and ready to land.Dec 1 2021, 5:09 AM
This revision was automatically updated to reflect the committed changes.